(* lists of tactics, script-expressions etc.
   WN.14.3.00
 *)

theory' := overwritel (! theory',
		       [(e_domID,Script.thy),
			("Script.thy",Script.thy)
			]);

(*.record all theories defined for Scripts; in order to distinguish them
   from general IsacKnowledge defined later on.*)
script_thys := !theory';


(*--vvv----- SHIFT? or delete ?*)
val IDTyp = Type("Script.ID",[]);


val tacs = ref (distinct
  ["Calculate",
   "Rewrite","Rewrite'_Inst","Rewrite'_Set","Rewrite'_Set'_Inst",
   "Substitute","Tac","Check'_elementswise",
   "Take","Subproblem","Or'_to'_List"] \ "");

val screxpr = ref (distinct
  ["Let","If","Repeat","While","Try","Or"] \ "");

val listfuns = ref [(*_all_ functions in Isa99.List.thy *)
    "@","filter","concat","foldl","hd","last","set","list_all",
    "map","mem","nth","list_update","take","drop",	
    "takeWhile","dropWhile","tl","butlast",
    "rev","zip","upt","remdups","nodups","replicate",

    "Cons","Nil"];

val scrfuns = ref (distinct
  ["Testvar"] \ "");

val listexpr = ref ((!listfuns) union (!scrfuns));

val notsimp = ref 
  (distinct (!tacs @ !screxpr @ (*!subpbls @*) !scrfuns @ !listfuns) \ "");

val negotiable = ref ((!tacs (*@ !subpbls*)));

val tacpbl = ref
  (distinct (!tacs (*@ !subpbls*)) \ "");
(*--^^^----- SHIFT? or delete ?*)










